codeforces 798

A 改变一个字符变成回文 统计要改变的数目  如果1个不一样是可以的  坑点是奇数的时候   可以改变中间那个

#include<stdio.h>
#include<algorithm>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<queue>
#include<deque>
#include<map>
#include<iterator>
#include<stack>

using namespace std;

#define ll   __int64
#define MAXN  100
#define inf  2000000007
char z[MAXN];

int main()
{
    scanf("%s",z);
    int len=strlen(z);
    int ok=0;

    int cnt=0;
    for(int i=0,j=len-1;i<len/2;i++,j--)
        if(z[i]!=z[j])
            cnt++;
    if(cnt==1)
        ok=0;
    else
        ok=1;
    if(len==1||cnt==0&&len%2==1)
        printf("YES\n");
    else
    {
        if(ok==0)
            printf("YES\n");
        else
            printf("NO\n");
    }
    return 0;
}

B 操作是移动第一个字母到最后  使得所有的字符串相同  问最少步数暴力每个能到达的串  更新步数

#include<stdio.h>
#include<algorithm>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<queue>
#include<deque>
#include<map>
#include<iterator>
#include<stack>

using namespace std;

#define ll   __int64
#define MAXN  110
#define inf  2000000007
char z[MAXN][MAXN],n1[MAXN];

int main()
{
    int n;
    while(scanf("%d",&n)!=EOF)
    {
        for(int i=1;i<=n;i++)
            scanf("%s",z[i]);
        strcpy(n1,z[1]);
        int len=strlen(n1);
        int mx=inf;
        int ok=0;
        for(int ind=0;ind<len;ind++)
        {
            int sum=0;
            for(int i=1;i<=n;i++)
            {
                int o1=0;

                for(int j=0;j<len;j++)
                {
                    int k,c1,kk;
                    for(k=j,c1=0,kk=ind;c1<len;k=(k+1)%len,c1++,kk=(kk+1)%len)
                        if(z[i][k]!=n1[kk])
                            break;
                    if(c1==len)
                    {
                        sum=sum+j;
                        o1=1;
                        break;
                    }
                }
                if(o1==0)
                    ok=1;
            }
            mx=min(mx,sum);
        }

        if(ok==1)
            printf("-1\n");
        else
            printf("%d\n",mx);
    }
    return 0;
}

C操作是改变相邻2个 变成a-b  a+b  最后答案是肯定有解的    因为变2步就是 -2a 2a 至少是2一开始要求一下gcd  可能都是奇数 然后不用变就>2

然后判断     i       i+1

奇数     奇数   1   1   0   2                             1步

奇数     偶数   1   2   -1  3  -4  2                   2步  

以此类推  最后一个数有点问题

#include<stdio.h>
#include<algorithm>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<queue>
#include<deque>
#include<map>
#include<iterator>
#include<stack>

using namespace std;

#define ll   __int64
#define MAXN  110000
#define inf  2000000007

int z[MAXN];
int gcd(int a,int b)
{
    return b?gcd(b,a%b):a;
}
int main()
{
    int n;
    while(scanf("%d",&n)!=EOF)
    {
        int d=0;
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&z[i]);
            d=gcd(d,z[i]);
        }
        if(d>1)
        {
            printf("YES\n0\n");
            continue;
        }
        int ans=0;
        for(int i=1;i<n;i++)
        {
            int c1=0;
            if(z[i]%2==1)
            {
                c1++;
                if(z[i+1]%2==1)
                    c1++;
                if(c1==1)
                {
                    ans=ans+2;
                    z[i]=z[i+1]=2;
                }
                else if(c1==2)
                {
                    ans=ans+1;
                    z[i]=z[i+1]=2;
                }
            }
        }
        if(z[n]%2==1)
            ans=ans+2;
        printf("YES\n%d\n",ans);
    }
    return 0;
}

D 要求取出的下标  的对应的值的和 *2>原来的

就是 取出来下标对应值  >剩下的

先按 a排序   那么取出肯定满足a  相邻2个取大的b  那么满足b   然后最后一个讨论下

#include<stdio.h>
#include<algorithm>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<queue>
#include<deque>
#include<map>
#include<iterator>
#include<stack>

using namespace std;

#define ll   __int64
#define MAXN  110000
#define inf  2000000007

struct node
{
    int a,b,i;
}c[MAXN];
bool cmp(node a,node b)
{
    return a.a>b.a;
}
int ans[MAXN];
bool vis[MAXN];

int main()
{
    int n;
    while(scanf("%d",&n)!=EOF)
    {
        memset(vis,0,sizeof(vis));
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&c[i].a);
            c[i].i=i;
        }
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&c[i].b);
        }
        sort(c+1,c+n+1,cmp);
        int cnt=1;
        ans[cnt++]=c[1].i;
        for(int i=2;i<=n;i=i+2)
        {
            if(i==n)
            {
                ans[cnt++]=c[i].i;
            }
            else
            {
                if(c[i].b>c[i+1].b)
                    ans[cnt++]=c[i].i;
                else
                    ans[cnt++]=c[i+1].i;
            }
        }

        printf("%d\n",cnt-1);
        for(int i=1;i<cnt-1;i++)
            printf("%d ",ans[i]);
        printf("%d\n",ans[cnt-1]);
    }
    return 0;
}

时间: 2024-10-15 08:48:40

codeforces 798的相关文章

4.30-5.1cf补题

//yy:拒绝转载!!! 悄悄告诉你,做题累了,去打两把斗地主就能恢复了喔~~~ //yy:可是我不会斗地主吖("'▽'") ~~~那就听两遍小苹果嘛~~~ 五一假期除了花时间建模,就抽空把最近没做的CF题补了点..毕竟明天开始又要继续上好多课呐...Yes, I can!(? •_•)?……(I can Huá shuǐ~~) codeforces 803 A. Maximal Binary Matrix   [简单构造] 题意:n行和n列填充零矩阵. 您要将k个1放在其中,使得得到

【算法系列学习】codeforces D. Mike and distribution 二维贪心

http://codeforces.com/contest/798/problem/D http://blog.csdn.net/yasola/article/details/70477816 对于二维的贪心我们可以先让它变成其中一维有序,这样只需要重点考虑另一维,就会简单很多. 首先,对于题目要求的选择元素之和两倍大与所有元素之和,我们可以转化为选择元素之和大于剩下的.然后我们可以将下标按照a从大到小排序.然后选择第一个,之后每两个一组,选择b大的一个,如果n是偶数再选择最后一个. 至于这样写

Codeforces 798D:Mike and distribution

Codeforces 798D:Mike and distributio 题目链接:http://codeforces.com/problemset/problem/798/D 题目大意:给出两个大小为$n$的数列$A,B$,现要求从这两个数列相同位置取出$K(K \leqslant n/2+1)$个数,使得$2 \times subA>sumA$且$2 \times subB>sumB$. 想法题 我们需要从数列$A$和数列$B$中取出$K$个数,使得这$K$个数的和比剩下$n-K$个数的和

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp